C $Header: /u/gcmpack/MITgcm/pkg/ptracers/ptracers_cycle.F,v 1.7 2012/03/08 17:13:31 jmc Exp $
C $Name: checkpoint64a $

#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_CYCLE

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_CYCLE( bi,bj,myTime,myIter,myThid )

C !DESCRIPTION:
C     Cycle time-stepping arrays

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  myTime               :: model time
C  myIter               :: time-step number
C  myThid               :: thread number
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  iTracer       :: loop indices
      INTEGER iTracer
CEOP

C Loop over passive tracers
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_StepFwd(iTracer) ) THEN

C Cycle time-stepping arrays
        CALL CYCLE_TRACER(
     I             bi,bj,
     U             pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     U             gPtr(1-OLx,1-OLy,1,1,1,iTracer),
     I             myTime,myIter,myThid )

C End of tracer loop
       ENDIF
      ENDDO

#endif /* ALLOW_PTRACERS */

      RETURN
      END
